﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace NASA.BeAMartian.TagGraph.Surveying
{
    public class ImageTagsRover : ImageFeatures
    {
        public ImageTagsRover()
        {
            this.Add(new ImageFeature(
                    ImageTagTypes.Rover,
                "Rover Features - Topside (Deck)",
                "Images that contain any part of the deck of the rover or any part of the rover that is mounted on the deck, such as calibration target, UHF antenna, high-gain antenna, camera mast, solar cells, etc.",
                img("rover-deck1.jpg")));

            this.Add(new ImageFeature(
                    ImageTagTypes.Rover,
                "Rover Features - Arm",
                "Images that contain any part of the rover arm when it is deployed, that is, extended from its stowed position on the rover body.",
                img("rover-arm1.jpg")));

            this.Add(new ImageFeature(
                    ImageTagTypes.Rover,
                "Rover Features - Rover Shadow",
                "Images of soil displaced by the rover wheels. Some images may only show tracks from one of the wheels or even multiple sets of tracks from the rover.",
                img("rover-tracks1.jpg")));

            this.Add(new ImageFeature(
                    ImageTagTypes.Rover,
                "Rover Features - Underside",
                "Images that contain any part of the deck of the rover or any part of the rover that is mounted on the deck, such as calibration target, UHF antenna, high-gain antenna, camera mast, solar cells, etc.",
                img("rover-deck1.jpg")));

            this.Add(new ImageFeature(
                    ImageTagTypes.Rover,
                "Rover Features - Wheels",
                "Images that contain any part of the deck of the rover or any part of the rover that is mounted on the deck, such as calibration target, UHF antenna, high-gain antenna, camera mast, solar cells, etc.",
                img("rover-deck1.jpg")));

            this.Add(new ImageFeature(
                    ImageTagTypes.Rover,
                "Rover Features - Sundial Shadow",
                "Images that contain any part of the deck of the rover or any part of the rover that is mounted on the deck, such as calibration target, UHF antenna, high-gain antenna, camera mast, solar cells, etc.",
                img("rover-deck1.jpg")));

            base.ContainsRoverTags = true;
        }
    }
}
