﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace NASA.BeAMartian.TagGraph.Surveying
{
    public class ImageTagsSky : ImageFeatures
    {
        public ImageTagsSky()
        {
            this.Add(new ImageFeature(
                    ImageTagTypes.Sky,
                    "Mars Features - Blank Sky",
                    "Images that contain a blank sky with no discernable features.",
                    img("all-sky1.jpg")));

            this.Add(new ImageFeature(
                    ImageTagTypes.Sky,
                    "Mars Features - Clouds",
                    "Images that contain one or more clouds.",
                    img("all-sky1.jpg")));

            this.Add(new ImageFeature(
                    ImageTagTypes.Sky,
                    "Mars Features - Sun",
                    "Images that feature the sun.",
                    img("all-sky1.jpg")));

            this.Add(new ImageFeature(
                    ImageTagTypes.Sky,
                "Mars Features - Stars",
                "Images that contain stars.",
                img("stars1.jpg")));

            base.ContainsSkyTags = true;
        }
    }
}
