using System;
using System.Xml;
using System.Xml.Serialization;
using System.Runtime.Serialization;
using System.Collections.Generic;

namespace GalaxyZoo.Client.Model
{
    [DataContract]
    [XmlType(AnonymousType = true)]
    [XmlRoot(IsNullable = false, ElementName="nudge_info", Namespace="")]
    public class NudgeInfo : AbstractGalaxyZooObject
    {
        [DataMember]
        [XmlElement(ElementName = "passed")]
        public bool Passed { get; set; }

        /// <summary>
        /// Gets/Set the OriginalMinLat property.
        /// </summary>
        [DataMember]
        [XmlElement(ElementName="original_min_lat")]
        public double OriginalMinLat { get; set; }

        /// <summary>
        /// Gets/Set the OriginalMinLong property.
        /// </summary>
        [DataMember]
        [XmlElement(ElementName="original_min_long")]
        public double OriginalMinLong { get; set; }

        /// <summary>
        /// Gets/Set the OriginalMaxLat property.
        /// </summary>
        [DataMember]
        [XmlElement(ElementName="original_max_lat")]
        public double OriginalMaxLat { get; set; }

        /// <summary>
        /// Gets/Set the OriginalMaxLong property.
        /// </summary>
        [DataMember]
        [XmlElement(ElementName="original_max_long")]
        public double OriginalMaxLong { get; set; }

        /// <summary>
        /// Gets/Set the DisplayedAtZoom property.
        /// </summary>
        [DataMember]
        [XmlElement(ElementName="displayed_at_zoom")]
        public double DisplayedAtZoom { get; set; }

        /// <summary>
        /// Gets/Set the NudgedXOffset property.
        /// </summary>
        [DataMember]
        [XmlElement(ElementName="nudged_x_offset")]
        public double NudgedXOffset { get; set; }

        /// <summary>
        /// Gets/Set the NudgedYOffset property.
        /// </summary>
        [DataMember]
        [XmlElement(ElementName="nudged_y_offset")]
        public double NudgedYOffset { get; set; }
    }
}
