using System;
using System.Xml;
using System.Xml.Serialization;
using System.Runtime.Serialization;
using System.Collections.Generic;

namespace GalaxyZoo.Client.Model
{
    [DataContract]
    [XmlType(AnonymousType = true)]
    [XmlRoot(IsNullable = false, ElementName="project", Namespace="")]
    public class Project : AbstractGalaxyZooObject
    {
        /// <summary>
        /// Gets/Set the Id property.
        /// </summary>
        [DataMember]
        [XmlElement(ElementName="id")]
        public int Id { get; set; }

        /// <summary>
        /// Gets/Set the Name property.
        /// </summary>
        [DataMember]
        [XmlElement(ElementName="name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets/Set the CreatedAt property.
        /// </summary>
        [DataMember]
        [XmlElement(ElementName="created_at")]
        public string CreatedAt { get; set; }

        /// <summary>
        /// Gets/Set the Active property.
        /// </summary>
        [DataMember]
        [XmlElement(ElementName="active")]
        public bool Active { get; set; }

        /// <summary>
        /// Gets/Set the Tasks property.
        /// </summary>
        [DataMember]
        [XmlElement(ElementName="tasks")]
        public int Tasks { get; set; }
    }
}
