﻿using System;
using System.Windows.Controls.Primitives;

namespace NASA.BeAMartian.Controls.Primitives
{
    public class ResizeEventArgs : EventArgs
    {
        public ResizeEventArgs(double horizontalDistance, double verticalDistance)
        {
            this.HorizontalDistance = horizontalDistance;
            this.VerticalDistance = verticalDistance;
        }

        /// <summary>
        /// Distance from the origin. The origin is defined as upperLeft.X + this.ActualWidth * this.RenderTransformOrigin.X and
        ///  upperLeft.Y + this.ActualHeight * this.RenderTransformOrigin.Y
        /// </summary>
        public double HorizontalDistance { get; protected set; }

        /// <summary>
        /// Distance from the origin. The origin is defined as upperLeft.X + this.ActualWidth * this.RenderTransformOrigin.X and
        ///  upperLeft.Y + this.ActualHeight * this.RenderTransformOrigin.Y
        /// </summary>
        public double VerticalDistance { get; protected set; }
    }
}
