﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using NASA.BeAMartian.Execution;

namespace NASA.BeAMartian.Helpers
{
    public class ExecutionQueueHelper
    {
        /// <summary>
        /// The singleton ExecutionQueueHelper.
        /// </summary>
        private static ExecutionQueueHelper singleton = null;

        /// <summary>
        /// Get the Singleton ExecutionQueueHelper
        /// </summary>
        public static ExecutionQueueHelper Instance
        {
            get
            {
                if (ExecutionQueueHelper.singleton == null)
                {
                    ExecutionQueueHelper.singleton = new ExecutionQueueHelper();
                }

                return ExecutionQueueHelper.singleton;
            }
        }

        private ExecutionQueue executionQueue = new ExecutionQueue();

        /// <summary>
        /// Private due to singleton. Use ExecutionQueueHelper.Instance.
        /// </summary>
        private ExecutionQueueHelper() { }

        public ExecutionQueue ExecutionQueue { get { return this.executionQueue; } }
    }
}
