﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Tasks;
using System.Windows.Navigation;
using System.Xml.Serialization;
using NASA.BeAMartian.Controls.Videos;
using System.Xml;
using System.IO;
using NASA.BeAMartian.Controls;

namespace NASA.BeAMartian.Views
{
    public partial class VideoList : PhoneApplicationPage
    {
        public VideoList()
        {
            InitializeComponent();

            lbOverview.Tag = new LoadMedia("Overview");
            lbTheMartians.Tag = new LoadMedia("TheMartians");
            lbBuildingCuriosity.Tag = new LoadMedia("BuildingCuriosity");
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            pvt.SelectedIndex = int.Parse(this.NavigationContext.QueryString["x"]);
            base.OnNavigatedTo(e);
        }

        private void pvt_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            string galleryName = (e.AddedItems[0] as PivotItem).Tag.ToString();
            string url = String.Format("http://beamdownload.blob.core.windows.net/media/WP7/videos/{0}.xml", galleryName);
            WebClient xmlClient = new WebClient();
            xmlClient.Headers["galleryName"] = galleryName;
            xmlClient.DownloadStringCompleted += new DownloadStringCompletedEventHandler(xmlClient_DownloadStringCompleted);
            xmlClient.DownloadStringAsync(new Uri(url, UriKind.Absolute));
        }

        void xmlClient_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            if (e.Error == null)
            {
                string uri = ((System.Net.WebClient)(sender)).BaseAddress.ToString();

                XmlSerializer x = new XmlSerializer(typeof(VideoItems));

                using (XmlReader reader = XmlReader.Create(new StringReader(e.Result)))
                {
                    string galleryName = (sender as WebClient).Headers["galleryName"];
                    VideoItems ig = (VideoItems)x.Deserialize(reader);
                    ListBox lb = FindName(String.Format("lb{0}", galleryName)) as ListBox;
                    (lb.Tag as LoadMedia).TotalItems = ig.Count;
                    lb.ItemsSource = ig;
                }
            }
        }

        private void Image_ImageOpened(object sender, RoutedEventArgs e)
        {
            Image img = sender as Image;
            ListBox lb = Utils.VisualTreeUtils.FindParentByType<ListBox>(img);
            LoadMedia lm = lb.Tag as LoadMedia;

            lm.Increment();

            if (lm.IsLoaded)
            {
                ProgressBar pb = FindName(String.Format("pb{0}", img.Tag.ToString())) as ProgressBar;
                pb.IsIndeterminate = false;
                pb.Visibility = System.Windows.Visibility.Collapsed;
                (Resources[String.Format("sbFadeIn{0}", img.Tag.ToString())] as Storyboard).Begin();
            }
        }

        private void ListBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (e.AddedItems.Count == 0) return;

            VideoItem igi = e.AddedItems[0] as VideoItem;

            MediaPlayerLauncher mediaPlayerLauncher = new MediaPlayerLauncher() 
            { 
                Media = new Uri(igi.VideoURL, UriKind.Absolute) 
            };

            mediaPlayerLauncher.Show();
        }
    }
}
